<script setup lang="ts">
import { useAppStore } from '@/store/app'
import { useSessionStore } from '@/store/session'
import API from '@/scripts/api'
import { useDataStore } from '@/store/data'

const app = useAppStore()
const session = useSessionStore()
const data = useDataStore()

function logout() {
  session.clearSession()
}
</script>

<template>
  <v-navigation-drawer v-model="app.navigationDrawer" location="right" :temporary="!app.isDesktop"
    :permanent="app.isDesktop">
    <v-list v-if="session.isActive">
      <v-list-item :title="session.display_name" :subtitle="data.ticketId ? `Ticket n°${data.ticketId}`+(!data.isTicketBound ? ' (En attente)' : '') : 'Pas de ticket'"></v-list-item>
    </v-list>

    <v-divider></v-divider>

    <v-list density="compact" nav>
      <v-list-item v-if="!session.isActive" prepend-icon="mdi-home" title="Accueil" exact link to="/"></v-list-item>
      <v-btn v-else to="/votes" class="tonal mb-2" color="primary" block>Votes</v-btn>
      <v-list-item v-if="session.isActive" prepend-icon="mdi-account-search" title="Utilisateurs" exact link
        to="/users/attending"></v-list-item>

      <v-list-item prepend-icon="mdi-text" title="Infos" exact link to="/info"></v-list-item>
      <v-list-item prepend-icon="mdi-help" title="Besoin d'aide ?" exact link to="/help"></v-list-item>
      <v-list-item prepend-icon="mdi-qrcode-scan" title="Ticket de présence" exact link to="/tickets/landing"
        :color="!data.isTicketBound ? 'error' : ''" :variant="!data.isTicketBound ? 'outlined' : undefined"></v-list-item>
    </v-list>

    <v-list v-if="session.isActive && session.role === 'operator'" density="compact" nav>
      <v-list-item>
        <div class="flex justify-between">
          <div>
            <p>Actions Opérateur</p>
          </div>
        </div>
      </v-list-item>
      <v-list-item prepend-icon="mdi-ballot-recount-outline" title="Gestion des votes" exact link
        to="/votes/management"></v-list-item>
      <v-list-item prepend-icon="mdi-account-search" title="Utilisateurs" exact link to="/users"></v-list-item>
      <v-list-item prepend-icon="mdi-ticket-account" title="Tickets de présence" exact link to="/tickets"></v-list-item>
      <v-list-item prepend-icon="mdi-account-alert" title="Droits de vote" exact link to="/voting-right-overrides"></v-list-item>
    </v-list>

    <v-list v-if="session.isActive && session.role === 'teller' || session.role === 'operator'" density="compact" nav>
      <v-list-item>
        <div class="flex justify-between">
          <div>
            <p>Actions Scrutateurs</p>
          </div>
        </div>
      </v-list-item>
      <v-list-item prepend-icon="mdi-ballot-recount-outline" title="Suivi des votes" exact link to="/votes/none/teller-monitoring"></v-list-item>
    </v-list>

    <v-list v-if="session.isActive">
      <v-list-item prepend-icon="mdi-refresh" subtitle="Actualiser les droits" @click="API.refreshJWT">
        <v-chip class="mx-1" label size="x-small" v-if="!session.role">
          Pas de rôle
        </v-chip>
        <v-chip class="mx-1" label size="x-small" color="red" v-if="session.role === 'operator'">
          Opérateur
        </v-chip>
        <v-chip class="mx-1" label size="x-small" color="orange" v-if="session.role === 'teller'">
          Scrutateur
        </v-chip>
        <v-chip class="mx-1" label size="x-small" color="blue" v-if="session.role === 'presence_agent'">
          Agent
        </v-chip>
      </v-list-item>
    </v-list>

    <v-list density="compact" nav>
      <v-list-item prepend-icon="mdi-cogs" title="Paramètres avancés" exact link to="/settings" />
      <v-list-item v-if="session.isActive" prepend-icon="mdi-door" title="Déconnexion" @click="logout" />
    </v-list>
  </v-navigation-drawer>
</template>
